#!/usr/bin/env python
# -*- coding: utf-8 -*-
 
#  Add quote in lyx using lyxclient

import os
import gtk
import pygtk
import referencer
from referencer import _

referencer_plugin_info = {
	"longname": _("Cite in OO"),
	"author": "Claudius Wilhelms",
	"ui":
		"""
		<ui>
			<menubar name='MenuBar'>
				<menu action='DocMenu'>
				<placeholder name='PluginDocMenuActions'>
					<menuitem action='_plugin_oo_cite'/>
				</placeholder>
				</menu>
			</menubar>
			<toolbar name='ToolBar'>
			<placeholder name='PluginToolBarActions'>
				<toolitem action='_plugin_oo_cite'/>
			</placeholder>
			</toolbar>
			<popup name='DocPopup'>
			<placeholder name='PluginDocPopupActions'>
				<menuitem action='_plugin_oo_cite'/>
			</placeholder>
			</popup>

		</ui>
		"""
}

referencer_plugin_actions = [
	{
	"name":        "_plugin_oo_cite",
	"label":     _("Cite in OO"),
	"tooltip":   _("Cite the selected documents in Openoffice"),
	"icon":        "oo.png",
	"callback":    "do_cite",
	"accelerator": "<control><shift>o"
	}
]



##read the path to the lyx pipe from the lyx configuration file
#if os.path.exists(LYXPREFS):
#	try:
#		p = open(LYXPREFS, "r")
#		while True:
#			l = p.readline()
#			if not l:
#				break
#			if l.startswith("\\serverpipe "):
#				LYXPIPE = l.split('"')[1] + ".in"
#				break
#		p.close()
#	except:
#		# Fall through to lyxclient
#		pass
#
## Locate lyxclient
#lyxClientBinary = None
#for dir in os.environ['PATH'].split (os.pathsep):
#	exe = os.path.join (dir, "lyxclient")
#	if (os.path.exists(exe)):
#		lyxClientBinary = exe
#		print "Found lyxclient at %s\n" % exe
#		break


def do_cite (library, documents):


#	LYXPIPE = None
#	HOME = os.environ.get("HOME")
#	LYXPREFS = os.path.join(HOME, ".lyx/preferences")
#	DEFAULTPIPE = os.path.join(HOME, ".lyxpipe.in")


# 	get the clipboard
	clipboard = gtk.clipboard_get()

	empty = True
	keys = ""
	for document in documents:
		if not empty:
			keys += ","
		keys += document.get_field("author")
		empty = False

	if empty:
		raise "No author"
		return False


# set the clipboard text data

	delimiter = ", "	
	author = "N.N."
	title = ""
	journal = ""
	pages = ""

	abbrv = document.get_field("author")[0:3]+document.get_field("year")[2:4]
	
#	if document.get_field("author").index("and") == 1:
#		author1 = document.get_field("author").split("and")[0]
#		author2 = document.get_field("author").split("and")[1]
#		author1 = author1.split(" ")
#		authorfirst1 =  author1[0]
#		authorname1 = author1[1]
#		authorfirst2 =  author2[0]
#		authorname2 = author2[1]
#		authormod = authorname1 + ","+authorfirst1[0:1]+".+delimiter+ "+authorname2 + ","+authorfirst2[0:1]+"."
#
#	else:
#		author1 = document.get_field("author")
#
#		author1 = author1.split(" ")
#
#		authorfirst1 =  author1[0]
#		authorname1 = author1[1]
#			
#		authormod = authorname1 + ","+authorfirst1[0:1]+"."		
	authormod = document.get_field("author")

	if len(document.get_field("author")) > 0: author = authormod+delimiter
	if len(document.get_field("title")) > 0: title = document.get_field("title")+delimiter
	if len(document.get_field("journal")) > 0: journal = document.get_field("journal")+delimiter
	if len(document.get_field("pages")) > 0: pages = "S."+document.get_field("pages")+delimiter

	if len(document.get_field("year")) > 0: year = document.get_field("year")


	clipstring = "["+abbrv+"]"+"\t"+author+title+journal+pages+year


#	def my_set_text(self, text, len=-1):
#	        targets = [ ("STRING", 0, 0),
#			    ("TEXT", 0, 1),
#                            ("COMPOUND_TEXT", 0, 2),
#                            ("UTF8_STRING", 0, 3) ]
#		def text_get_func(clipboard, selectiondata, info, data):
#	            selectiondata.set_text(data)
#        	    return
#		def text_clear_func(clipboard, data):
#     	            del data      	  
#		    return
#	    
#         	self.set_with_data(targets, text_get_func, text_clear_func, text)
#         	return


	clipboard.set_text(clipstring,-1)


# make our data available to other applications
	clipboard.store()

#
#	existing_lyxpipe = None
#	if LYXPIPE and os.path.exists(LYXPIPE):
#		existing_lyxpipe = LYXPIPE
#	elif os.path.exists(DEFAULTPIPE):
#		existing_lyxpipe = DEFAULTPIPE
#
#	if existing_lyxpipe is not None:	
#		try:
#			print "using lyx pipe: "+existing_lyxpipe
#			p = open(existing_lyxpipe, 'a')
#			p.write("LYXCMD:referencer:citation-insert:" + keys + "\n")
#			p.close()
#			return True
#		except:
#			print "Error using the lyx pipe"
#	elif lyxClientBinary is not None:
#		# Compose citation insertion command
#		cmdStr = "LYXCMD:citation-insert " + keys + "\n"
#		try:
#			retval = os.system ("%s -c \"%s\"" % (lyxClientBinary, cmdStr))
#		except:
#			return False
#
#		if retval != 0:
#			raise "LyXClient failed, is LyX running?"
#	else:
#		raise "Couldn't find lyxclient"
#		#return False
#
#	return True

